--Disable map zoom outside dungeons
local ZO_MapPanAndZoom = {MAX_OVER_ZOOM = 0.589}
function ZO_MapPanAndZoom:CanMapZoom()
    return GetMapContentType() ~= MAP_CONTENT_DUNGEON
end
function ZO_MapPanAndZoom:ComputeMinZoom()
    return 1
end
function ZO_MapPanAndZoom:ComputeMaxZoom()
    if(not self:CanMapZoom()) then
        return 1
    else
        local numTiles = GetMapNumTiles()
        local tilePixelWidth = ZO_WorldMapContainer1:GetTextureFileDimensions()
        local totalPixels = numTiles * tilePixelWidth
        local mapAreaUIUnits = ZO_WorldMapScroll:GetHeight()
        local mapAreaPixels = mapAreaUIUnits * GetUIGlobalScale()
        local maxZoomToStayBelowNative = totalPixels / mapAreaPixels
        return zo_max(maxZoomToStayBelowNative * ZO_MapPanAndZoom.MAX_OVER_ZOOM, 0.589)
    end
end

local function ChangeZoomLimit()
    local FACTOR = 1
    local minZoom = ZO_MapPanAndZoom:ComputeMinZoom()
    local maxZoom = ZO_MapPanAndZoom:ComputeMaxZoom()
    ZO_WorldMap_SetCustomZoomLevels(minZoom, maxZoom * FACTOR)
end

local orig_ZO_WorldMap_ShowWorldMap = ZO_WorldMap_ShowWorldMap
ZO_WorldMap_ShowWorldMap = function()
    orig_ZO_WorldMap_ShowWorldMap()
    ZO_WorldMap_ClearCustomZoomLevels()
    zo_callLater(ChangeZoomLimit, 1)
end

local orig_ZO_WorldMap_UpdateMap = ZO_WorldMap_UpdateMap
ZO_WorldMap_UpdateMap = function()
    orig_ZO_WorldMap_UpdateMap()
    ZO_WorldMap_ClearCustomZoomLevels()
    zo_callLater(ChangeZoomLimit, 1)
end
